﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using RestSharp;

namespace AMESRestful.Controllers
{
    public class MESInfo_ViewController : Controller
    {
        // GET: MESInfo_View
        public ActionResult Index()
        {
            return View();
        }

        


        public class ini_para
        {
            // for ini 
            public string ProjName;
            public string NodeName;
            public string UserName;
            public string Password;
            public string BasicAuth;
        }
       
        public ActionResult Q_Input(string id = null, string TagName = null,
            string LINE_DESC = null, string WIP_NO = null,
            string PN = null, string LOT = null, string SIDE = null, string TOTAL_QTY = null, string FAIL_QTY = null)
        {
            // ViewData
            ViewData["POST_MSG_Q"] = "";
            ViewData["TagName_Q"] = TagName;
            ViewData["LINE_DESC_Q"] = LINE_DESC = id;
            ViewData["WIP_NO_Q"] = WIP_NO;
            ViewData["PN_Q"] = PN;
            ViewData["LOT_Q"] = LOT;
            ViewData["SIDE_Q"] = SIDE;
            ViewData["TOTAL_QTY_Q"] = TOTAL_QTY;
            ViewData["FAIL_QTY_Q"] = FAIL_QTY;

            string SetupIniFileName = System.AppDomain.CurrentDomain.BaseDirectory + "Setup.ini";
            CIniFile SetupIni = new CIniFile(SetupIniFileName);

            if (id != null)
            {
                if (ViewData["TagName_Q"] == null)
                {
                    ViewData["TagName_Q"] = SetupIni.IniReadValue("Line_Tag_Mapping_Q", id);
                    ViewData["TEXT_READONLY_Q"] = "true";
                }
                else
                {
                    ViewData["TagName_Q"] = TagName;
                }
            }
            else
            {
                ViewData["TagName_Q"] = null;
            }

            string send_str = "'{\"TagName\":\"" + ViewData["TagName_Q"] + "\"," +
                "\"TagInfo\":[{" +
                "\"LINE_DESC\":\"" + ViewData["LINE_DESC_Q"] + "\"," +
                "\"WIP_NO\":\"" + ViewData["WIP_NO_Q"] + "\"," +
                "\"PN\":\"" + ViewData["PN_Q"] + "\"," +
                "\"LOT\":\"" + ViewData["LOT_Q"] + "\"," +
                "\"SIDE\":\"" + ViewData["SIDE_Q"] + "\"," +
                "\"TOTAL_QTY\":\"" + ViewData["TOTAL_QTY_Q"] + "\"," +
                "\"FAIL_QTY\":\"" + ViewData["FAIL_QTY_Q"] + "\",}]}'";


            if ( ViewData["LINE_DESC_Q"] != null && ViewData["WIP_NO_Q"] != null && ViewData["SIDE_Q"] != null && ViewData["TOTAL_QTY_Q"] != null && ViewData["FAIL_QTY_Q"] != null)
            {
                ViewData["POST_MSG_Q"] = fnSendRequestJSON(send_str, "mesinfo_Q");
            }
            else
            {
                ViewData["POST_MSG_Q"] = "format error";
            }

            return View();
        }
        

            // Methods
        public ActionResult A_Input(string id = null, string TagName = null,
            string UPLOAD_TYPE = null, string LINE_DESC = null, string WIP_NO = null,
            string PN = null, string LOT = null, string PLAN_QTY = null, string SIDE = null,
            string START_TIME = null, string END_TIME = null, string STD_WORK_TIME = null)
        {
            // ViewData
            ViewData["POST_MSG_A"] = "";
            ViewData["TagName_A"] = TagName;
            ViewData["LINE_DESC_A"] = LINE_DESC = id;
            ViewData["UPLOAD_TYPE_A"] = UPLOAD_TYPE;
            ViewData["WIP_NO_A"] = WIP_NO;
            ViewData["PN_A"] = PN;
            ViewData["LOT_A"] = LOT;
            ViewData["PLAN_QTY_A"] = PLAN_QTY;
            ViewData["SIDE_A"] = SIDE;
            ViewData["START_TIME_A"] = START_TIME;
            ViewData["END_TIME_A"] = END_TIME;
            ViewData["STD_WORK_TIME_A"] = STD_WORK_TIME;

            string SetupIniFileName = System.AppDomain.CurrentDomain.BaseDirectory + "Setup.ini";
            CIniFile SetupIni = new CIniFile(SetupIniFileName);

            if (id != null)
            {
                if (ViewData["TagName_A"] == null)
                {
                    ViewData["TagName_A"] = SetupIni.IniReadValue("Line_Tag_Mapping_A", id);
                    ViewData["TEXT_READONLY_A"] = "true";
                }
                else
                {
                    ViewData["TagName_A"] = TagName;
                }
            }
            else
            {
                ViewData["TagName_A"] = null;
            }

            if (ViewData["START_TIME_A"] == null)
            {
                ViewData["START_TIME_A"] = DateTime.Now.ToString("o");
            }

            string send_str = "'{\"TagName\":\"" + ViewData["TagName_A"] + "\"," +
                "\"TagInfo\":[{" +
                "\"UPLOAD_TYPE\":\"" + ViewData["UPLOAD_TYPE_A"] + "\"," +
                "\"LINE_DESC\":\"" + ViewData["LINE_DESC_A"] + "\"," +
                "\"WIP_NO\":\"" + ViewData["WIP_NO_A"] + "\"," +
                "\"PN\":\"" + ViewData["PN_A"] + "\"," +
                "\"LOT\":\"" + ViewData["LOT_A"] + "\"," +
                "\"PLAN_QTY\":\"" + ViewData["PLAN_QTY_A"] + "\"," +
                "\"SIDE\":\"" + ViewData["SIDE_A"] + "\"," +
                "\"START_TIME\":\"" + ViewData["START_TIME_A"] + "\"," +
                "\"END_TIME\":\"" + ViewData["END_TIME_A"] + "\"," +
                "\"STD_WORK_TIME\":\"" + ViewData["STD_WORK_TIME_A"] + "\",}]}'";

              
            if (ViewData["UPLOAD_TYPE_A"] != null && ViewData["LINE_DESC_A"] != null && ViewData["WIP_NO_A"] != null && ViewData["PLAN_QTY_A"] != null && ViewData["SIDE_A"] != null && ViewData["STD_WORK_TIME_A"] != null)
            {
                ViewData["POST_MSG_A"] = fnSendRequestJSON(send_str, "mesinfo_A");
            }
            else
            {
                ViewData["POST_MSG_A"] = "format error";
            }

            return View();
        }

        public ActionResult Quality_Defect(string id = null, string QD_CODE = null, string TagName = null)
        {
            ViewData["QD_CODE"] = QD_CODE;
            ViewData["LINE_DESC_E"] = id;

            string SetupIniFileName = System.AppDomain.CurrentDomain.BaseDirectory + "Setup.ini";
            CIniFile SetupIni = new CIniFile(SetupIniFileName);

            if (id != null)
            {
                if (ViewData["TagName_E"] == null)
                {
                    ViewData["TagName_E"] = SetupIni.IniReadValue("Line_Tag_Mapping_E", id);
                    ViewData["TEXT_READONLY_QD"] = "true";
                }
                else
                {
                    ViewData["TagName_E"] = TagName;
                }
            }
            else
            {
                ViewData["TagName_E"] = null;
            }

            string send_str = "'{\"TagName\":\"" + ViewData["TagName_E"] + "\"," +
                "\"TagInfo\":[{" +

                "\"ERR_CODE\":\"" + ViewData["QD_CODE"] + "\",}]}'";

            if (ViewData["LINE_DESC_E"] != null && ViewData["TagName_E"] != null )
            {
                ViewData["POST_MSG_E"] = fnSendRequestJSON(send_str, "ErrorCode");
            }
            else
            {
                ViewData["POST_MSG_E"] = "format error";
            }

            return View();
        }

        public ActionResult Equipment_Error(string id = null, string EE_CODE = null, 
            string TagName = null, string Equipment_code_temp = null, string Equipment_code = null)
        {
            ViewData["EE_CODE"] = EE_CODE;
            ViewData["LINE_DESC_EE"] = id;
            ViewData["EE_CODE_TEMP"] = Equipment_code_temp;

            string SetupIniFileName = System.AppDomain.CurrentDomain.BaseDirectory + "Setup.ini";
            CIniFile SetupIni = new CIniFile(SetupIniFileName);

            if (id != null)
            {
                if (ViewData["TagName_EE"] == null)
                {
                    ViewData["TagName_EE"] = SetupIni.IniReadValue("Line_Tag_Mapping_E", id);
                    ViewData["TEXT_READONLY_EE"] = "true";
                }
                else
                {
                    ViewData["TagName_EE"] = TagName;
                }
            }
            else
            {
                ViewData["TagName_EE"] = null;
            }

            if (EE_CODE == Equipment_code)
            {
                ViewData["EE_CODE"] = "NO_ERR";
                EE_CODE = "NO_ERR";
            }
            
            string send_str = "'{\"TagName\":\"" + ViewData["TagName_EE"] + "\"," +
                "\"TagInfo\":[{" +

                "\"ERR_CODE\":\"" + ViewData["EE_CODE"] + "\",}]}'";

            if (ViewData["EE_CODE"] != null && ViewData["TagName_EE"] != null)
            {
                ViewData["POST_MSG_EE"] = fnSendRequestJSON(send_str, "ErrorCode");
            }
            else
            {
                ViewData["POST_MSG_EE"] = "format error";
            }
           
            ViewData["EE_CODE_TEMP"] = Equipment_code;
            
            return View();
        }

        public string fnSendRequestJSON(string sBody, string info_type)//傳至amesresf
        {
            {
                #region post value
                string sHttpURLRequest = "http://" + Request.Url.Authority + "//api/" + info_type ;
                var client = new RestClient(sHttpURLRequest);
                var request = new RestRequest(Method.POST);

                //request.AddHeader("Authorization", "Basic YWRtaW46");
                request.AddHeader("Content-Type", "application/json");
                request.AddParameter("application/json", sBody, ParameterType.RequestBody);
                IRestResponse response = client.Execute(request);
                //display
                //txtResponse.AppendText(response.Content.ToString());
                //txtResponse.AppendText("\r\n");
                #endregion
                //判斷是否上傳成功
                if (response.StatusCode.ToString() != "OK")
                {
                    return response.Content.ToString();
                }
                else
                {
                    return response.Content.ToString();
                }
            }
        }

    }
}