﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
// queue
using System.Collections;
// txt r/w
using System.IO;
// string clear
using System.Text.RegularExpressions;
// 
using RestSharp;
// json r/w
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.Data;
namespace AMESRestful.Models
{
    public class TagValues_para
    {
        public bool bFlagPostToWAExecuting = false;
        public bool bFlagTimerFirstTigger = false;
    }

    public class ini_para
    {
        // for ini 
        public string ProjName;
        public string NodeName;
        public string UserName;
        public string Password;
        public string BasicAuth;

        public string MSG_interval;
        public int intMSG_interval;
    }


    public class TagValues
    {
        //建立Queue的物件 myqueue
        static public Queue myQueue = new Queue();
        static public Queue myQueue_Err = new Queue();
        static private TagValues_para TagValues_Flag = new TagValues_para();
        static public ini_para TagValues_ini = new ini_para();

        string checktag = ""; //要驗證webaccess Get 回來的值比對的Tag
        string[] checkTagValue = new string[10];  //要驗證webaccess Get 回來的值比對的陣列

        static string SetupIniFileName = System.AppDomain.CurrentDomain.BaseDirectory + "Setup.ini";
        CIniFile SetupIni = new CIniFile(SetupIniFileName);

        // 20190909
        int gSendFailCounts = 0 ;
        int gSendFailCounts_Err = 0;

        //[WebMethod]
        public void fnQuePush(string item,string Device,string[] InputArray, int queueType)
        {
            if (queueType == 0)
            {
                lock (myQueue)
                {
                    myQueue.Enqueue(item);
                    fnTimerLoadOnce();
                }
            }
            else if(queueType == 1)
            {
                lock (myQueue_Err)
                {
                    myQueue_Err.Enqueue(item);
                    fnTimerLoadOnce();
                }
            }
        }

        public void fnTimerLoadOnce()
        {
            if (TagValues_Flag.bFlagTimerFirstTigger == false)
            {
                // 取得wa info
                TagValues_ini.ProjName = SetupIni.IniReadValue("WA_Data", "ProjName");
                TagValues_ini.NodeName = SetupIni.IniReadValue("WA_Data", "NodeName");
                TagValues_ini.UserName = SetupIni.IniReadValue("WA_Data", "UserName");
                TagValues_ini.Password = SetupIni.IniReadValue("WA_Data", "Password");
                TagValues_ini.MSG_interval = SetupIni.IniReadValue("WA_Data", "MSG_interval");

                
                int num_MSG_interval;
                if (int.TryParse(TagValues_ini.MSG_interval, out num_MSG_interval))
                {
                    TagValues_ini.intMSG_interval = num_MSG_interval;
                }
                else
                {
                    TagValues_ini.intMSG_interval = 1000;
                }

                string id_pw = TagValues_ini.UserName + ":" + TagValues_ini.Password;
                byte[] auth_bytes = System.Text.Encoding.GetEncoding("utf-8").GetBytes(id_pw);
                //編成 Base64 字串
                TagValues_ini.BasicAuth = "Basic " + Convert.ToBase64String(auth_bytes);

                TagValues_Flag.bFlagTimerFirstTigger = true;
                Timer2_Load(null, null);
            }
        }

        //[WebMethod]
        public string fnQuePop(int queueType)
        {
            if (queueType == 0)
                lock (myQueue)
                {
                    if (myQueue.Count != 0)
                    {
                        return (string)myQueue.Dequeue();
                    }
                    return "-1";
                }
            else
            {
                lock (myQueue_Err)
                {
                    if (myQueue_Err.Count != 0)
                    {
                        return (string)myQueue_Err.Dequeue();
                    }
                    return "-1";
                }
            }
        }

        public void fnMESDataRecodWrite(string sLogPath,string inputMESRecordStr)
        {
            try
            {
                //StreamWriter sw = new StreamWriter(@"C:\\WebServiceMESDataRecord.txt", true);
                //StreamWriter sw = new StreamWriter(@sLogPath, true);
                ////第二個參數設定為true表示不覆蓋原本的內容，把新內容直接添加進去
                ////sw.WriteLine(@sLogPath);
                //sw.WriteLine(inputMESRecordStr);
                //sw.Close();
                FileStream fs = new FileStream(sLogPath, System.IO.FileMode.Append, System.IO.FileAccess.Write);
                StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);     
                sw.WriteLine(inputMESRecordStr);

                sw.Close();
                fs.Close();
     
            }
            catch
            {
                Console.Write(sLogPath + " Write Error");
            }
        }

        public string fnCleanInput(string strIn)
        {
            if (strIn != null)
            {
                // Replace invalid characters with empty strings.
                try
                {
                    return strIn.Replace("\n", "").Replace("\r", "").Replace(" ", "").Replace("\t", "");
                }
                // If we timeout when replacing invalid characters, 
                // we should return Empty.
                catch (RegexMatchTimeoutException)
                {
                    return String.Empty;
                }
            }
            else
            {
                return String.Empty;
            }
        }

        public bool fnSendRequestJSON(string sBody)
        {
            try
            {
                TagValues_Flag.bFlagPostToWAExecuting = true;
                //disable 20181004
                {
                    JObject jo = JObject.Parse(sBody);
                    //string MESTagName = jo["TAGNAME"].ToString() + "(";
                    //解第一層
                    string Layer_1 = jo["Tags"].ToString();
                    JArray ja = (JArray)JsonConvert.DeserializeObject(Layer_1);

                    string[] arrTagValue = new string[10];
                    //string jtPara1 = "";
                    string jtPara2 = "";
                    //tmrRS.Enabled = false;

                    JToken jTagTmp = null;
                    jTagTmp = jo.SelectToken("Tags[0].Name");
                    checktag = jTagTmp.ToString().Replace("(0)", "(");
                    if (checktag.IndexOf("A") > 1) //A資料在做
                    {

                        for (int i = 0; i < 10; i++)
                        {
                            //jtPara1 = "TagInfo[" + InfoType[i] + "]";
                            jtPara2 = "Tags[" + i.ToString() + "].Value";
                            //(string)o.SelectToken("school.students[1].name");
                            JToken jtValueTmp = null;
                            jtValueTmp = jo.SelectToken(jtPara2);
                            if (jtValueTmp != null)
                            {
                                if (i == 7 || i == 8)
                                {
                                    if (jtValueTmp.ToString() != string.Empty)
                                    {
                                        checkTagValue[i] = DateTime.Parse(jtValueTmp.ToString()).ToString("o") + "+08:00";
                                    }
                                    else
                                    {
                                        checkTagValue[i] = "";
                                    }
                                }
                                else
                                {
                                    checkTagValue[i] = jtValueTmp.ToString();
                                }
                            }
                            else
                            {
                                checkTagValue[i] = "";
                            }
                        }
                    }
                    
                    //login
                    //fnLogin(txtIP.Text);
                    #region logon
                    var Logonclient = new RestClient("http://127.0.0.1/WaWebService/Json/Logon");
                    //var Logonclient = new RestClient("http://172.22.72.71/WaWebService/Json/Logon");
                    var Logonrequest = new RestRequest(Method.GET);
                    //Logonrequest.AddHeader("Postman-Token", "60ec7789-1068-40df-aa6f-d976d2f61852");
                    //Logonrequest.AddHeader("cache-control", "no-cache");
                    Logonrequest.AddHeader("Authorization", TagValues_ini.BasicAuth);
                    IRestResponse Logonresponse = Logonclient.Execute(Logonrequest);
                    #endregion

                    #region post value
                    string sHttpURLRequest = "http://127.0.0.1/WaWebService/Json/SetTagValueText/" + TagValues_ini.ProjName + "/" + TagValues_ini.NodeName;
                    //string sHttpURLRequest = "http://172.22.72.71/WaWebService/Json/SetTagValueText/" + TagValues_ini.ProjName + "/" + TagValues_ini.NodeName;
                    var client = new RestClient(sHttpURLRequest);
                    var request = new RestRequest(Method.POST);

                    request.AddHeader("Authorization", TagValues_ini.BasicAuth);
                    request.AddHeader("Content-Type", "application/json");
                    request.AddParameter("application/json", sBody, ParameterType.RequestBody);
                    IRestResponse response = client.Execute(request);
                    //display
                    //txtResponse.AppendText(response.Content.ToString());
                    //txtResponse.AppendText("\r\n");
                    #endregion
                    //判斷是否上傳成功
                    if (response.Content.ToString() != "{\"Ret\":0}")
                    {  
                        //tmrRS.Enabled = false;
                        //txtResponse.AppendText(DateTime.Now.ToString() + " Send Request JSON FAIL\r\n" + response.Content.ToString());
                        //toolStripStatusLabel2.Text = "Send Request JSON FAIL";
                        fnMESDataRecodWrite("C:\\Logs\\AMESRestful_FAIL_MSG.txt", DateTime.Now.ToString() + " (line 205) response check Fail, " + response.Content.ToString());
                        TagValues_Flag.bFlagPostToWAExecuting = false;
                        return false;
                    }
                    else
                    {
                        if (checktag.IndexOf("A") > 1)
                        {
                            if (CheckWebaccessTagValue(checkTagValue, checktag) == false)
                            {
                                TagValues_Flag.bFlagPostToWAExecuting = false;
                                return false;
                            }
                            else
                            {
                                TagValues_Flag.bFlagPostToWAExecuting = false;
                                return true;
                            }
                        }
                        else
                        {
                            TagValues_Flag.bFlagPostToWAExecuting = false;
                            return true;
                        }  
                    }
                }
            }
            catch (Exception ex)
            {
                return false;
            }
        }

        static private System.Timers.Timer _TimersTimer ;
        //private System.Timers.Timer _TimersTimer2;
        private void Timer2_Load(object sender, EventArgs e)
        {  
             _TimersTimer = new System.Timers.Timer();
             _TimersTimer.Interval = TagValues_ini.intMSG_interval;
             _TimersTimer.Elapsed += new System.Timers.ElapsedEventHandler(_TimersTimer_Elapsed);
             _TimersTimer.Start();   
        }

        void _TimersTimer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            //bFlagTimer = true;
            //在這裡做想做的事      
            if (myQueue.Count > 0 && TagValues_Flag.bFlagPostToWAExecuting == false)
            {
                if (fnSendRequestJSON(myQueue.Peek().ToString()) == true)
                {
                    fnMESDataRecodWrite("C:\\Logs\\AMESRestfulSend_PASS.csv", DateTime.Now.ToString() + " upload PASS, " + fnCleanInput(myQueue.Peek().ToString().Trim()));
                    fnQuePop(0);
                    gSendFailCounts = 0;
                }
                else
                {
                    //do no thing
                    fnMESDataRecodWrite("C:\\Logs\\AMESRestfulSend_FAIL.csv", DateTime.Now.ToString() + " upload failed, " + fnCleanInput(myQueue.Peek().ToString().Trim()));

                    gSendFailCounts++;

                    if (gSendFailCounts > 4)
                    {
                        fnQuePop(0);
                        fnMESDataRecodWrite("C:\\Logs\\AMESRestfulSend_FAIL.csv", DateTime.Now.ToString() + " retry 5 times, dequeue data ");
                    }
                }
            }

            if (myQueue_Err.Count > 0 && TagValues_Flag.bFlagPostToWAExecuting == false)
            {
                if (fnSendRequestJSON(myQueue_Err.Peek().ToString()) == true)
                {
                    fnMESDataRecodWrite("C:\\Logs\\AMESRestfulSend_PASS.csv", DateTime.Now.ToString() + " upload PASS, " + fnCleanInput(myQueue_Err.Peek().ToString().Trim()));
                    fnQuePop(1);
                    gSendFailCounts_Err = 0;
                }
                else
                {
                    //do no thing
                    fnMESDataRecodWrite("C:\\Logs\\AMESRestfulSend_FAIL.csv", DateTime.Now.ToString() + " upload failed, " + fnCleanInput(myQueue_Err.Peek().ToString().Trim()));

                    gSendFailCounts_Err++;

                    if (gSendFailCounts_Err > 4)
                    {
                        fnQuePop(1);
                        fnMESDataRecodWrite("C:\\Logs\\AMESRestfulSend_FAIL.csv", DateTime.Now.ToString() + " retry 5 times, dequeue data ");
                    }
                }
            }
        }

        private bool CheckWebaccessTagValue(string[] InputArray,string Device)
        {
            try
            {
                string sendBody = "{\"Tags\":[";
                for (int i = 0; i < 10; i++)
                {
                    {
                        sendBody += "{\"Name\":\"" + Device + i.ToString() + ")\"}";
                        if (i != 10 - 1)
                        {
                            sendBody += ", ";
                        }
                    }
                }
                sendBody += "]}";

                #region logon
                var Logonclient = new RestClient("http://127.0.0.1/WaWebService/Json/Logon");
                //var Logonclient = new RestClient("http://172.22.72.71/WaWebService/Json/Logon");
                var Logonrequest = new RestRequest(Method.GET);
                Logonrequest.AddHeader("Authorization", TagValues_ini.BasicAuth);
                IRestResponse Logonresponse = Logonclient.Execute(Logonrequest);
                #endregion

                #region post value
                string sHttpURLRequest = "http://127.0.0.1/WaWebService/Json/GetTagValueText/" + TagValues_ini.ProjName + "/" + TagValues_ini.NodeName;
                //string sHttpURLRequest = "http://172.22.72.71/WaWebService/Json/GetTagValueText/" + TagValues_ini.ProjName + "/" + TagValues_ini.NodeName;
                var client = new RestClient(sHttpURLRequest);
                var request = new RestRequest(Method.POST);

                request.AddHeader("Authorization", TagValues_ini.BasicAuth);
                request.AddHeader("Content-Type", "application/json");
                request.AddParameter("application/json", sendBody, ParameterType.RequestBody);
                IRestResponse response = client.Execute(request);
                //display
                //txtResponse.AppendText(response.Content.ToString());
                //txtResponse.AppendText("\r\n");
                #endregion
                //判斷是否上傳成功
                if (response.StatusCode.ToString() != "OK")
                {
                    return false;
                }
                else
                {
                    JObject jo = JObject.Parse(response.Content.ToString());
                    //解第一層
                    string Layer_1 = jo["Values"].ToString();
                    JArray ja = (JArray)JsonConvert.DeserializeObject(Layer_1);

                    string[] arrTagValue = new string[10];
                    string jtPara2 = "";
                    for (int i = 0; i < 10; i++)
                    {
                        jtPara2 = "Values[" + i.ToString() + "].Value";
                        JToken jtValueTmp = null;
                        jtValueTmp = jo.SelectToken(jtPara2);
                        if (jtValueTmp != null)
                        {
                            if (i == 7 || i == 8)
                            {
                                if (jtValueTmp.ToString() != string.Empty)
                                {
                                    arrTagValue[i] = DateTime.Parse(jtValueTmp.ToString()).ToString("o") + "+08:00";
                                }
                                else
                                {
                                    arrTagValue[i] = "";
                                }         
                            }
                            else
                            {
                                arrTagValue[i] = jtValueTmp.ToString();
                            }
                        }
                        else
                        {
                            arrTagValue[i] = "";
                        }
                    }
                    for(int i=0;i < checkTagValue.Length;i++)
                    {
                        if (arrTagValue[i].ToString().Trim() != checkTagValue[i].ToString().Trim())
                        {
                            //fnMESDataRecodWrite("C:\\Logs\\WebaccessTagCheck.csv", DateTime.Now.ToString() + " check Fail, " + fnCleanInput(myQueue.Peek().ToString().Trim()));
                            fnMESDataRecodWrite("C:\\Logs\\AMESRestful_FAIL_MSG.txt", DateTime.Now.ToString() + " (line 426) checkTagValue check Fail, " + arrTagValue[i].ToString().Trim() + " != " + checkTagValue[i].ToString().Trim());
                            return false;
                        }
                    }

                }
                return true;
            }

            catch (Exception ex)
            {
                fnMESDataRecodWrite("C:\\Logs\\AMESRestful_FAIL_MSG.txt", DateTime.Now.ToString() + " (line 438) Check function check Fail, " + ex);
                return false;
            }
        }

       

    }
}